/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : board.h
* @author    : FMD AE
* @brief     : Header for board.c module
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __BOARD_H
#define __BOARD_H

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Public Constant prototypes----------------------------------------------------*/
/* Public typedef ---------------------------------------------------------------*/
typedef enum
{
    KEY_None = 0,
    KEY1_Data,
    KEY2_Data,
} KEY_DATA;

/* Public define ----------------------------------------------------------------*/
/* LED PORT, PIN, ON, OFF define */
#define LED_PORT                        GPIOB

#define LED1_PIN                        GPIO_Pin_0
#define LED2_PIN                        GPIO_Pin_1
#define LED3_PIN                        GPIO_Pin_2
#define LED4_PIN                        GPIO_Pin_3

#define LED1_ON                     GPIO_ResetBits(LED_PORT,LED1_PIN)
#define LED1_OFF                    GPIO_SetBits(LED_PORT,LED1_PIN)
#define LED2_ON                     GPIO_ResetBits(LED_PORT,LED2_PIN)
#define LED2_OFF                    GPIO_SetBits(LED_PORT,LED2_PIN)
#define LED3_ON                     GPIO_SetBits(LED_PORT,LED3_PIN)
#define LED3_OFF                    GPIO_ResetBits(LED_PORT,LED3_PIN)
#define LED4_ON                     GPIO_SetBits(LED_PORT,LED4_PIN)
#define LED4_OFF                    GPIO_ResetBits(LED_PORT,LED4_PIN)

#define LED_OFF                         {   LED1_OFF;\
                                                            LED2_OFF;\
                                                            LED3_OFF;\
                                                            LED4_OFF;}

/* KEY PORT, PIN ,Read input define */
#define KEY_PORT                        GPIOC
#define KEY1_PIN                        GPIO_Pin_13
#define KEY2_PIN                        GPIO_Pin_11

#define KEY1_INPUT_READ         GPIO_ReadInputDataBit(KEY_PORT,KEY1_PIN)
#define KEY2_INPUT_READ         GPIO_ReadInputDataBit(KEY_PORT,KEY2_PIN)

/* Public variables prototypes --------------------------------------------------*/
/* Public function prototypes----------------------------------------------------*/
void LED_Init(void);
void LED_Flash(uint8_t FlashRate);
void KEY_Init(void);
void KEY_Pro(void);
void SysTick_Configuration(void);
void USART_Config(void);
void ADC_Config(void);
void ADC_Measure(void);
void IWDG_Init(void);
void TIM_Config(void);
int fputc(int ch, FILE *f);

#endif /* __BOARD_H */

/************************ (C) COPYRIGHT FMD *****END OF FILE****/
