/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : bsp_dac.c
* @author    : FMD AE
* @brief     : bsp_dac program body
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "bsp_dac.h"
/* Private Constant --------------------------------------------------------------*/
/* Public Constant ---------------------------------------------------------------*/
/* Private typedef ---------------------------------------------------------------*/
/* Private variables -------------------------------------------------------------*/
/* Public variables --------------------------------------------------------------*/

/* Private function prototypes ---------------------------------------------------*/

/* Public function ------ --------------------------------------------------------*/
/**********************************************************************************
  * @brief  DAC_Config program
  * @param  None
  * @note
  * @retval None
  *********************************************************************************
*/

uint8_t read_tmp = 0;
/**
    *   @Parame
    */
void Bsp_DAC_Config(void)
{
    /*DAC clock enable*/
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);
    /*Set reference voltage: 2V*/
    DAC_Ref_Config(DAC_CTRL_REF_SEL_0);
    //dac1
    DAC_SetChannel1Data(1, 0x10); //?
    read_tmp = DAC_Read_Reg(DAC_DATA1_READ);
    if (read_tmp == 0x10)
    {
        __NOP();//ok
    }
    //dac2
    DAC_SetChannel2Data(2, 0x7f);
    read_tmp = DAC_Read_Reg(DAC_DATA2_READ);
    if (read_tmp == 0x7f)
    {
        __NOP();//ok
    }

    DAC_Cmd(ENABLE);

    read_tmp = DAC_Read_Reg(DAC_CTRL_READ);
    if (read_tmp == (DAC_CTRL_REF_SEL_0 | DAC_CTRL_EN))
    {
        __NOP();//ok
    }
}


/************************* (C) COPYRIGHT FMD *****END OF FILE*********************/
