/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : main.c
* @author    : FMD AE
* @brief     : main program body
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{
    /*!< At this stage the microcontroller clock setting is already configured,
       this is done through SystemInit() function which is called from startup
       file (startup_ft32f0xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_ft32f0xx.c file
     */

    /* DMA1 channel1 configuration ---------------------------------------------*/
    DMA_Config();

    /* Wait the end of transmission */
    while (EndOfTransfer == 0)
    {
    }

    /* Check if the destination "DstBuffer" and source "SrcBuffer" buffers are equal */
    TransferStatus = Buffercmp(SrcBuffer, DstBuffer, BUFFER_SIZE);
    /* TransferStatus = PASSED, destination and source buffers are the same */
    /* TransferStatus = FAILED, destination and source buffers are different */

    while (1)
    {
    }
}

/************************ (C) COPYRIGHT Fremont Micro Devices *****END OF FILE****/
