/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : bsp_spi.h
* @author    : FMD AE
* @brief     : Header for bsp_spi.c module
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __BSP_SPI_H
#define __BSP_SPI_H

/* Includes ---------------------------------------------------------------------*/
#include "ft32f0xx.h"

/* Public Constant prototypes----------------------------------------------------*/
extern const uint16_t spi1_tx_buff[];
extern const uint16_t spi2_tx_buff[];

/* Public typedef ---------------------------------------------------------------*/
/* Public define ----------------------------------------------------------------*/
#define RX_SIZE 19

/* SPI1 */
#define    SPI1_PORT    GPIOA
#define    SPI1_NSS     GPIO_Pin_4
#define    SPI1_SCK     GPIO_Pin_5
#define    SPI1_MISO    GPIO_Pin_6
#define    SPI1_MOSI    GPIO_Pin_7

#define    SPI1_NSS_PIN_SOURCE    GPIO_PinSource4
#define    SPI1_SCK_PIN_SOURCE    GPIO_PinSource5
#define    SPI1_MISO_PIN_SOURCE    GPIO_PinSource6
#define    SPI1_MOSI_PIN_SOURCE    GPIO_PinSource7

#define    SPI1_NSS_AF     GPIO_AF_0
#define    SPI1_SCK_AF     GPIO_AF_0
#define    SPI1_MISO_AF    GPIO_AF_0
#define    SPI1_MOSI_AF    GPIO_AF_0

/* SPI2 */
#define    SPI2_PORT    GPIOB
#define    SPI2_NSS     GPIO_Pin_12
#define    SPI2_SCK     GPIO_Pin_13
#define    SPI2_MISO    GPIO_Pin_14
#define    SPI2_MOSI    GPIO_Pin_15

#define    SPI2_NSS_PIN_SOURCE    GPIO_PinSource12
#define    SPI2_SCK_PIN_SOURCE    GPIO_PinSource13
#define    SPI2_MISO_PIN_SOURCE    GPIO_PinSource14
#define    SPI2_MOSI_PIN_SOURCE    GPIO_PinSource15

#define    SPI2_NSS_AF     GPIO_AF_0
#define    SPI2_SCK_AF     GPIO_AF_0
#define    SPI2_MISO_AF    GPIO_AF_0
#define    SPI2_MOSI_AF    GPIO_AF_0

/* Public variables prototypes --------------------------------------------------*/
extern uint8_t data_addr;
extern uint16_t spi1_rx_buff[];
extern uint16_t spi2_rx_buff[];
extern uint8_t rece_cnt2;

/* Public function prototypes----------------------------------------------------*/
void Bsp_SPI1_IT_Config(void);
void Delay(uint32_t time);
void Bsp_DMA_SPI1_TX_RX_Config(void);

#endif /* __BSP_I2C_H */
/************************ (C) COPYRIGHT Fremont Micro Devices *****END OF FILE****/
