/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : bsp_dma.h
* @author    : FMD AE
* @brief     : Header for bsp_dma.c module
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __BSP_DMA_H
#define __BSP_DMA_H

/* Includes ------------------------------------------------------------------*/
#include "ft32f0xx.h"

/* Exported types ------------------------------------------------------------*/
typedef enum {FAILED = 0, PASSED = !FAILED} TestStatus;
/* Exported constants --------------------------------------------------------*/
//extern __IO uint32_t EndOfTransfer;
//extern __IO TestStatus TransferStatus;
//extern const uint32_t SrcBuffer[];
//extern uint32_t DstBuffer[];

///* Exported macro ------------------------------------------------------------*/
//#define BUFFER_SIZE  32
///* Exported functions ------------------------------------------------------- */
//void DMA_Config(void);
//TestStatus Buffercmp(const uint32_t* pBuffer, uint32_t* pBuffer1, uint16_t BufferLength);


/* Exported typedef ----------------------------------------------------------*/
#define countof(a)   (sizeof(a) / sizeof(*(a)))

/* Communication boards USART Interface */
#define USART1_RDR_Address    0x40013824
#define USART1_TDR_Address    0x40013828

#define USART2_RDR_Address    0x40004424
#define USART2_TDR_Address    0x40004428

#define TXBUFFERSIZE          (countof(TxBuffer1) - 1)
#define RXBUFFERSIZE          TXBUFFERSIZE



void RCC_Config(void);
void GPIO_Config(void);
TestStatus Buffercmp(uint8_t *pBuffer1, uint8_t *pBuffer2, uint16_t BufferLength);
void IniDmaUsart(void);
void DmaUsartTransfer(void);


#endif /* __BSP_DMA_H */

/************************ (C) COPYRIGHT Fremont Micro Devices *****END OF FILE****/
