/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : eeprom_FT24C02A.h
* @author    : FMD AE
* @brief     : Header for eeprom_FT24C02A.c module
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

#ifndef __EEPROM_FT24C02A_H
#define __EEPROM_FT24C02A_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ---------------------------------------------------------------------*/
#include "FT32f0xx.h"

/* Public Constant --------------------------------------------------------------*/


/* Public typedef ---------------------------------------------------------------*/


/* Public define ----------------------------------------------------------------*/
#define sEE_HW_ADDRESS     0xA0   /* E2 = 0 */
#define sEE_I2C_TIMING         0xF0210507  //when =SYSCLK=48MHZ
#define sEE_PAGESIZE           16
#define sEE_FLAG_TIMEOUT         ((uint32_t)0x1000)
#define sEE_LONG_TIMEOUT         ((uint32_t)(10 * sEE_FLAG_TIMEOUT))
#define sEE_MAX_TRIALS_NUMBER     300
#define sEE_OK                    0
#define sEE_FAIL                  1
/* Public variables -------------------------------------------------------------*/
extern __IO uint16_t  sEEAddress;

/* Public function prototypes----------------------------------------------------*/
void     sEE_Init(void);
uint32_t sEE_ReadBuffer(uint8_t *pBuffer, uint16_t ReadAddr, uint16_t *NumByteToRead);
uint32_t sEE_WritePage(uint8_t *pBuffer, uint16_t WriteAddr, uint8_t *NumByteToWrite);
void     sEE_WriteBuffer(uint8_t *pBuffer, uint16_t WriteAddr, uint16_t NumByteToWrite);
uint32_t sEE_WaitEepromStandbyState(void);
uint32_t sEE_TIMEOUT_UserCallback(void);
#ifdef __cplusplus
}
#endif
#endif

/************************ (C) COPYRIGHT FMD *****END OF FILE****/
