/**
    ******************************************************************************
    * @file         ft32f0xx_it.c
    * @author       FMD AE
    * @brief        Main Interrupt Service Routines.
    *               This file provides template for all exceptions handler and
    *               peripherals interrupt service routine.
    * @version      V1.0.0
    * @data         2022-05-30
    ******************************************************************************
    * @attention
    * COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
    * This software is provided by the copyright holders and contributors,and the
    *   software is believed to be accurate and reliable. However, Fremont Micro
    *   Devices (SZ) Corporation assumes no responsibility for the consequences of
    *   use of such software or for any infringement of patents of other rights
    *   of third parties, which may result from its use. No license is granted by
    *   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
    *   Corporation.
    ******************************************************************************
    */
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __FT32F0XX_it_H
#define __FT32F0XX_it_H


/* Includes ---------------------------------------------------------------------*/
#include "ft32f0xx.h"
#include "bsp_i2c.h"

#ifdef __cplusplus
extern "C" {
#endif
/* Public Constant prototypes----------------------------------------------------*/
/* Public typedef ---------------------------------------------------------------*/
/* Public define ----------------------------------------------------------------*/
/* Public variables prototypes --------------------------------------------------*/
/* Public function prototypes----------------------------------------------------*/
void NMI_Handler(void);
void HardFault_Handler(void);
void SVC_Handler(void);
void PendSV_Handler(void);
void SysTick_Handler(void);
void I2C2_IRQHandler(void);

#ifdef __cplusplus
}
#endif

#endif /* __FT32F0XX_IT_H */

/************************ (C) COPYRIGHT Fremont Micro Devices *****END OF FILE****/
