/**
    ******************************************************************************
    * @file         bsp_i2c.h
    * @author       FMD AE
    * @brief        Header for bsp_i2c.c module
    * @version      V1.0.0
    * @data         2022-05-30
    ******************************************************************************
    * @attention
    * COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
    * This software is provided by the copyright holders and contributors,and the
    *   software is believed to be accurate and reliable. However, Fremont Micro
    *   Devices (SZ) Corporation assumes no responsibility for the consequences of
    *   use of such software or for any infringement of patents of other rights
    *   of third parties, which may result from its use. No license is granted by
    *   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
    *   Corporation.
    ******************************************************************************
    */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __BSP_I2C_H
#define __BSP_I2C_H

/* Includes ---------------------------------------------------------------------*/
#include "ft32f0xx.h"

/* Public Constant prototypes----------------------------------------------------*/
/* Public typedef ---------------------------------------------------------------*/
/* Public define ----------------------------------------------------------------*/
//#define   I2C_SEND_SIZE   5

#define SLAVE_DEVICE_ADDR       0x7a
#define SLAVE_DEVICE_ADDR10     0x37a
/* Public variables prototypes --------------------------------------------------*/
extern uint8_t send_buff[];
extern uint8_t receive_buff[];
extern uint16_t recev_cnt;
extern uint16_t I2C_SEND_SIZE;
extern uint16_t match_addr;
extern uint8_t smbus_mode;

/* Public function prototypes----------------------------------------------------*/
void Bsp_I2C_INTERRUPT_Mode_Config(void);
void I2C_Send_MutiByte(uint8_t addr, uint8_t *dat, uint8_t len);
void Delay(uint32_t us);

#endif /* __BSP_I2C_H */
/************************ (C) COPYRIGHT Fremont Micro Devices *****END OF FILE****/

