/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : main.c
* @author    : FMD AE
* @brief     : main program body
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Includes ----------------------------------------------------------------------*/
#include "main.h"
#include "bmp.h"

/* Private Constant --------------------------------------------------------------*/

/* Private typedef ---------------------------------------------------------------*/

/* Private define ----------------------------------------------------------------*/

/* Private variables -------------------------------------------------------------*/

/* Public variables --------------------------------------------------------------*/


/* Private function prototypes ---------------------------------------------------*/
void Delay(uint32_t us);
/**********************************************************************************
  * @brief  main program.
  * @param  None
  * @note
  * @retval None
  *********************************************************************************
*/

int main(void)
{
    Delay(1000);
    OLED_Init();
    OLED_ColorTurn(0);//0 Normal display1 reverse color display

    while (1)
    {
        OLED_Clear();
        OLED_ShowChinese(18, 0, 0, 16, 1); //
        OLED_ShowChinese(36, 0, 1, 16, 1); //â
        OLED_ShowChinese(54, 0, 2, 16, 1); //΢
        OLED_ShowChinese(72, 0, 3, 16, 1); //
        OLED_ShowChinese(90, 0, 4, 16, 1); //
        OLED_ShowString(18, 16, "Fremontmicro", 16, 1);
        OLED_ShowString(20, 32, "2021/09/17", 16, 1);
        OLED_ShowString(0, 48, "ASCII:", 16, 1);
        OLED_ShowString(63, 48, "CODE:", 16, 1);
        OLED_ShowChar(48, 48, '!', 16, 1); //ASCII char
        OLED_ShowNum(103, 48, 123, 3, 16, 1);
        OLED_Refresh();
        Delay(10000);
        OLED_Clear();
        OLED_ShowPicture(0, 0, 128, 64, BMP3, 1);
        OLED_Refresh();
        Delay(10000);
    }
}
/* Private function ------ -------------------------------------------------------*/
/**********************************************************************************
  * @brief  Delay program.
  * @param  None
  * @note
  * @retval None
  *********************************************************************************
*/
void Delay(uint32_t us)
{
    uint32_t i, j;
    for (i = us; i > 0; i--)
    {
        for (j = 0; j < 1000; j++)
        {
            __ASM("NOP");
        }
    }
}
/************************ (C) COPYRIGHT FMD *****END OF FILE****/
