
/**
  *********************************************************************************
  * @file           FT32F0xx_it.c
  * @author         FMD AE
  * @brief          FT32F0xx_it program body.
  * @version        V1.0.0
  * @data           2022-05-30
  *********************************************************************************
  * @attention
  * COPYRIGHT (C) 2021 Fremont Micro Devices Corporation All rights reserved.
  *    This software is provided by the copyright holders and contributors,and the
  *software is believed to be accurate and reliable. However, Fremont Micro Devices
  *Corporation assumes no responsibility for the consequences of use of such
  *software or for any infringement of patents of other rights of third parties,
  *which may result from its use. No license is granted by implication or otherwise
  *under any patent rights of Fremont Micro Devices Corporation.
  *  ******************************************************************************
  */

/* Includes ----------------------------------------------------------------------*/
#include "FT32F0xx_it.h"
#include "bsp_i2c.h"

uint8_t CurrentAdrSlaveDevAdr[100],adrcnt=0;
uint8_t readStatus=0;
uint8_t *read_data_ptr;
extern uint8_t I2C_DIR,senddata;
extern uint8_t send_buff[256];
/** @addtogroup FT32f0xx_StdPeriph_Examples
  * @{
  */

/** @addtogroup USART_2xUsartsOneBoard
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/******************************************************************************/
/*            Cortex-M0 Processor Exceptions Handlers                         */
/******************************************************************************/

/**
  * @brief  This function handles NMI exception.
  * @param  None
  * @retval None
  */
void NMI_Handler(void)
{
}

/**
  * @brief  This function handles Hard Fault exception.
  * @param  None
  * @retval None
  */
void HardFault_Handler(void)
{
    while (1)
    {
    }
}
/**
  * @brief  This function handles SVCall exception.
  * @param  None
  * @retval None
  */
void SVC_Handler(void)
{
}

/**
  * @brief  This function handles PendSVC exception.
  * @param  None
  * @retval None
  */
void PendSV_Handler(void)
{
}

/**
  * @brief  This function handles SysTick Handler.
  * @param  None
  * @retval None
  */
void SysTick_Handler(void)
{

}
/**
  * @brief  This function handles I2C2 Handler.
  * @param  None
  * @retval None
  */
void I2C2_IRQHandler(void)
{
	uint8_t i;
    if (I2C_GetITStatus(I2C2, I2C_IT_RXNE) != RESET)
    {
        receive_buff[recev_cnt++] = I2C_ReceiveData(I2C2);
        if (recev_cnt >= I2C_SEND_SIZE)
        {
            recev_cnt = 0;
        }	
				if(readStatus == DEVADDRMATCHING)
				{//send first data from eeprom_adr
					readStatus = DEVINITIAL;
					read_data_ptr = &send_buff[EEPROM_ADR+receive_buff[0]];
					I2C2->TXDR = *read_data_ptr++;
				}
    }
		
		if (I2C_GetITStatus(I2C2, I2C_IT_ADDR) != RESET)//clear address 
		{//device adr matching
			I2C2->ICR |= I2C_ICR_ADDRCF;
			readStatus = DEVADDRMATCHING;
			recev_cnt = 0;
		}
		if (I2C_GetITStatus(I2C2, I2C_IT_STOPF) != RESET)
		{
			I2C2->ISR |= 0X01;
			I2C2->ICR |= I2C_ICR_STOPCF;
			I2C_DIR = (((uint32_t)I2C2->ISR & I2C_ISR_DIR) >> 16);
			if(I2C_DIR == 0)
			{
				read_data_ptr = &send_buff[EEPROM_ADR+receive_buff[0]];
				for(i = 0; i < recev_cnt; i++)
					*read_data_ptr++ = receive_buff[1+i];
			}
		}
		
		if (I2C_GetITStatus(I2C2, I2C_IT_TXIS) != RESET)
		{//load data
			I2C2->TXDR = *read_data_ptr++;
		}

}
/************************ (C) COPYRIGHT Fremont Micro Devices *****END OF FILE****/
