/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : main.c
* @author    : FMD AE
* @brief     : main program body
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{
//  uint16_t LedCnt = 0;
    /*!< At this stage the microcontroller clock setting is already configured,
       this is done through SystemInit() function which is called from startup
       file (startup_ft32f0xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_ft32f0xx.c file
     */

    /* Initialize LED-related GPIO */
    LedConfig(LED1);
    LedConfig(LED2);
    LedConfig(LED3);
    LedConfig(LED4);

    while (1)
    {
        LedToggle(LED1);
        DelayNms(300);

        LedToggle(LED3);
        DelayNms(300);


        LedToggle(LED4);
        DelayNms(300);

        LedToggle(LED2);
        DelayNms(300);
    }
}

/**
  * @brief  DelayNus program.
  * @param  time: This value can range from 0 to 0xffFFFFFF.
  * @retval None
  */
void DelayNus(uint32_t time)
{
    uint32_t i, j;
    /*when sysclk equal 48M ,the delay is about 1us*/
    for (i = 0; i < time; i++)
    {
        for (j = 0; j < 4; j++)
        {
            __NOP();
        }
    }
}

/**
  * @brief  DelayNms program.
  * @param  time: This value can range from 0 to 0xffFFFFFF.
  * @retval None
  */
void DelayNms(uint32_t time)
{
    for (uint32_t i = 0; i < time; i++)
    {
        DelayNus(1000);
    }
}

/************************ (C) COPYRIGHT Fremont Micro Devices *****END OF FILE****/
