/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : bsp_opa.c
* @author    : FMD AE
* @brief     : bsp_opa program body
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "bsp_opa.h"
/* Private Constant --------------------------------------------------------------*/
/* Public Constant ---------------------------------------------------------------*/
/* Private typedef ---------------------------------------------------------------*/
/* Private variables -------------------------------------------------------------*/
/* Public variables --------------------------------------------------------------*/

/* Private function prototypes ---------------------------------------------------*/

/* Public function ------ --------------------------------------------------------*/
/**********************************************************************************
  * @brief  OPA_Config program
  * @param  None
  * @note
  * @retval None
  *********************************************************************************
*/
void OPA_Config(void)
{
    OPA_InitTypeDef OPA_InitStructure;
    GPIO_InitTypeDef GPIO_InitStructure;
    //=============================================================
    //       OPA1
    //=============================================================
    /* GPIOA Peripheral clock enable */
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);

    /* Configure PA1 in analog mode: PA1 is connected to OPA1 non inverting input */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    /* Configure PA2 in analog mode: PA2 is connected to OPA1 inverting input */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    /* Configure PA0 in output mode: PA0 is connected to OPA1 output */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_Level_3;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    /* Enable SYSCFG clock */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);
    //
    OPA_Cali(OPA);
    //
    OPA->CR &= (~(0x1f << 1));
    OPA->CR |= (0x10 << 1);
    OPA_InitStructure.OPA_OP0NSel = OPA_VIN_SEL_R4K_GND;
    OPA_InitStructure.OPA_OP0PSel = OPA1_VIP_SEL_PA1;
    OPA_InitStructure.OPA_OP0FR = OPA_FR_SEL_40K;
    OPA_InitStructure.OPA_OP0FCAPE = OPA_FCAP_SEL_EN;
    OPA_InitStructure.OPA_OPTODIG = OPA_ODIG_SEL_DIS;
    OPA_InitStructure.OPA_OPTOIO = OPA_OIO_SEL_EN;//ΪPA0
    OPA_Init(OPA, &OPA_InitStructure);
    //
    OPA_Cmd(OPA, ENABLE);
}

/************************* (C) COPYRIGHT FMD *****END OF FILE*********************/
