/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : bsp_Timer.c
* @author    : FMD AE
* @brief     : bsp_Timer program body
* @version   : V1.0.0
* @data      : 2022-06-02
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "bsp_Timer.h"

/* Private macro -------------------------------------------------------------*/


/* Private variables ---------------------------------------------------------*/

/**********************************************************************************
  * @brief  TIM6_Config program.
  * @param  none
  * @note
  * @retval None
  *********************************************************************************
*/
void TIM6_Config(void)
{
    TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure;
    
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM6,ENABLE);
    TIM_Cmd(TIM6, DISABLE);
    
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CounterMode_Up;
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CKD_DIV1;
    TIM_TimeBaseInitStructure.TIM_Period = 65535;
    TIM_TimeBaseInitStructure.TIM_Prescaler = SystemCoreClock/1000000 - 1;
    TIM_TimeBaseInitStructure.TIM_RepetitionCounter = 0;
    TIM_TimeBaseInit(TIM6, &TIM_TimeBaseInitStructure);
    
    TIM_Cmd(TIM6, ENABLE);
}
/**********************************************************************************
  * @brief  delay_us program.
  * @param  t --delay time us
  * @note
  * @retval None
  *********************************************************************************/
void delay_us(uint32_t t)
{
		TIM6->CNT = 0;
    while (t >= TIM6->CNT)
    {
        ;
    }
}
/**********************************************************************************
  * @brief  delay_ms program.
  * @param  t --delay time ms
  * @note
  * @retval None
  *********************************************************************************/
void delay_ms(uint32_t t)
{
	uint16_t i = 0;
	for(; i < t; i++)
	{
		delay_us(1000);
	}
}
