/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : bsp_tim_IR.h
* @author    : FMD AE
* @brief     : Header for bsp_tim_IR.c module
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

#ifndef __DRIVER_TIM_IR_H
#define __DRIVER_TIM_IR_H

/* Includes ---------------------------------------------------------------------*/

#include "FT32f0xx.h"
#include <stdint.h>

typedef struct
{
    uint16_t period;
    uint16_t pulse;
} STRUCT_PULSE;

typedef struct
{
    STRUCT_PULSE data[100];
		uint16_t dataCnt;
		uint8_t RecData[10];
    uint8_t busy;
    uint8_t adr;
		uint8_t status;
		uint16_t cnt;
		uint8_t  recFlg;
		uint8_t AnaCnt;
} STRUCT_IR;

extern STRUCT_IR IR;

/* Public Constant prototypes----------------------------------------------------*/

/* Public typedef ---------------------------------------------------------------*/

/* Public define ----------------------------------------------------------------*/

/* Public variables prototypes --------------------------------------------------*/

/* Public function prototypes----------------------------------------------------*/
void TIM_Capture_Config(void);
void SendIRdata(void);
uint8_t AnalyseIrProtocol(void);
#endif /* __DRIVER_LED_H */

/************************* (C) COPYRIGHT FMD *****END OF FILE*********************/
