/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : bsp_tim_IR.c
* @author    : FMD AE
* @brief     : bsp_tim_IR program body
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "bsp_tim_IR.h"
#include "bsp_Pwm.h"
//#include "ft32f0xx_touch.h"
/* Private Constant --------------------------------------------------------------*/
/* Public Constant ---------------------------------------------------------------*/
/* Private typedef ---------------------------------------------------------------*/
/* Private variables -------------------------------------------------------------*/
/* Public variables --------------------------------------------------------------*/

/* Private function prototypes ---------------------------------------------------*/

/* Public function ------ --------------------------------------------------------*/


STRUCT_IR IR;
extern STRUCT_IR IR_Rec;
extern uint16_t IRcnt;
extern void EnTouch(void);
/**********************************************************************************
  * @brief  SendIRbyte program.
  * @param  data
  * @note
  * @retval None
  *********************************************************************************
*/

void SendIRbyte(uint8_t data)
{
	uint8_t i,senddata;
	senddata = data;
	for(i = 0; i < 8; i++)
	{
		if(senddata&0x01)
		{
			IR.data[IR.dataCnt].period = 2170;
			IR.data[IR.dataCnt].pulse = 560;
		}
		else
		{
			IR.data[IR.dataCnt].period = 1120;
			IR.data[IR.dataCnt].pulse = 560;
		}
		IR.dataCnt++;
		senddata >>= 1;
	}
}

/**********************************************************************************
  * @brief  SendIRdata program.
  * @param  none
  * @note
  * @retval None
  *********************************************************************************
*/
void SendIRdata(void)
{

		IR.dataCnt = 0;
		//start data
    IR.data[IR.dataCnt].period = 8410;
    IR.data[IR.dataCnt].pulse = 4480;
    IR.dataCnt++;
    
		SendIRbyte(0x99);
		SendIRbyte(0xAA);
		SendIRbyte(0x55);
    //end data
    IR.data[IR.dataCnt].period = 8410;
    IR.data[IR.dataCnt].pulse = 4480;
		IR.dataCnt++;
		IR_Rec.status = 0;
		IR_Rec.cnt = 0;
		IR_Rec.adr = 0;
		
		IR.adr = 0;
    IR.busy = 1;
}
/**********************************************************************************
  * @brief  GetIrRecData program.
  * @param  none
  * @note
  * @retval None
  *********************************************************************************
*/
uint8_t GetIrRecData(void)
{
	uint8_t temp=0,i,k=0;
			for(i = 0+IR_Rec.AnaCnt; i < (8+IR_Rec.AnaCnt); i++)
			{
//				temp <<=1;
				if(((IR_Rec.data[i].pulse <= 562)&&(IR_Rec.data[i].pulse >= 558))&&((IR_Rec.data[i].period <= 2172)&&(IR_Rec.data[i].period >= 2168)))
				{
					temp |= 0x01<<k;
				}
				else if(((IR_Rec.data[i].pulse <= 562)&&(IR_Rec.data[i].pulse >= 558))&&((IR_Rec.data[i].period <= 1122)&&(IR_Rec.data[i].period >= 1118)))
				{
					temp |= 0x00<<k;
				}
				else
				{
					return 0xff;
				}
				k++;
			}	
	return temp;
}
/**********************************************************************************
  * @brief  AnalyseIrProtocol program.
  * @param  none
  * @note
  * @retval None
  *********************************************************************************
*/
uint8_t AnalyseIrProtocol(void)
{
	uint8_t temp=0,i,n=0;
	if((IRcnt >= 1000)&&(IR_Rec.recFlg))
	{
//		EnTouch();
		IR_Rec.recFlg = 0;
		//analyse start flag
		IR_Rec.AnaCnt = 0;
		if(((IR_Rec.data[IR_Rec.AnaCnt].pulse <= 4482)&&(IR_Rec.data[IR_Rec.AnaCnt].pulse >= 4478))&&((IR_Rec.data[IR_Rec.AnaCnt].period <= 8412)&&(IR_Rec.data[IR_Rec.AnaCnt].period >= 8408)))
		{
			IR_Rec.AnaCnt++;
			IR_Rec.adr--;
				for(i = 0; i < 10; i++)
				{
					if(IR_Rec.adr>=8)
						IR_Rec.RecData[n] = GetIrRecData();
					else
						break;
					IR_Rec.adr -= 8;
					IR_Rec.AnaCnt +=8;
					n++;
				}
				if((IR_Rec.RecData[0] == 0x99)&&(IR_Rec.RecData[1] == 0xAA)&&(IR_Rec.RecData[2] == 0x55))
					temp = 1;
		}
	}
	
	return temp;
}
/************************* (C) COPYRIGHT FMD *****END OF FILE*********************/
