/**
	******************************************************************************
	* @file 		main.c
	* @author 	    FMD AE
	* @brief 		Main program body
	* @version 	    V1.0.0
	* @data 		2021-09-14
	******************************************************************************
	* @attention
	* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
	* This software is provided by the copyright holders and contributors,and the
	*	software is believed to be accurate and reliable. However, Fremont Micro
	*	Devices (SZ) Corporation assumes no responsibility for the consequences of
	*	use of such software or for any infringement of patents of other rights
	*	of third parties, which may result from its use. No license is granted by
	*	implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
	*	Corporation.
	******************************************************************************
	*/

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private Constant --------------------------------------------------------------*/
/* Public Constant ---------------------------------------------------------------*/
/* Private typedef ---------------------------------------------------------------*/
/* Private define ----------------------------------------------------------------*/
/* Private variables -------------------------------------------------------------*/
/* Public variables --------------------------------------------------------------*/
uint8_t received_data = 0;
uint8_t received_data1 = 0;

/* Private function prototypes ---------------------------------------------------*/
/* Public function ------ --------------------------------------------------------*/
/* Private function ------ -------------------------------------------------------*/

static void USART_Send(USART_TypeDef* USARTx,uint8_t dat);

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{
    /*!< At this stage the microcontroller clock setting is already configured, 
	this is done through SystemInit() function which is called from startup
	file (startup_ft32f0xx.s) before to branch to application main.
	To reconfigure the default setting of SystemInit() function, refer to
	system_ft32f0xx.c file
	*/
    uint8_t data = 0xff,data1 = 0;
    
    /* USART configuration */
    USART1_Config();
    USART2_Config();
    
    USART_Send(USART1, data);

    while (1)
    {
        if (USART_GetFlagStatus(USART2,USART_FLAG_RXNE) != RESET)
        {
            received_data1 = USART_ReceiveData(USART2);
            
            data1 = (data1 >= 255)?  0 : data1 + 1;
            
            USART_Send(USART2, data1);
        }  

        if (USART_GetFlagStatus(USART1,USART_FLAG_RXNE) != RESET)
        {
            received_data = USART_ReceiveData(USART1);
            
            data = (data <=0)?  255 : data - 1;
            
            USART_Send(USART1, data);
        }         
    }
}

/**
  * @brief  USART_Send program.
  * @param  dat
  * @retval None
  */
static void USART_Send(USART_TypeDef* USARTx,uint8_t dat)
{
    USART_DirectionModeCmd(USARTx,USART_Mode_Rx,DISABLE);
    USART_DirectionModeCmd(USARTx,USART_Mode_Tx,ENABLE);
    
    USART_SendData(USARTx,dat);
    
    while (USART_GetFlagStatus(USARTx,USART_FLAG_TC) == 0);
    while (USART_GetFlagStatus(USARTx,USART_FLAG_IDLE) == 0);
    USART_ClearFlag(USARTx,USART_FLAG_IDLE);
    
    USART_DirectionModeCmd(USARTx,USART_Mode_Tx,DISABLE);
    USART_DirectionModeCmd(USARTx,USART_Mode_Rx,ENABLE); 
}
/************************ (C) COPYRIGHT Fremont Micro Devices *****END OF FILE****/
