/**
  ******************************************************************************
  * @file           bsp_usb.h
  * @author         FMD AE
  * @brief          This file contains all the functions prototypes for the bsp_usb
  * @version        V1.0.0
  * @data           2022-01-13
  ******************************************************************************
  * @attention
  * COPYRIGHT (C) 2021 Fremont Micro Devices Corporation All rights reserved.
  *    This software is provided by the copyright holders and contributors,and the
  *software is believed to be accurate and reliable. However, Fremont Micro Devices
  * Corporation assumes no responsibility for the consequences of use of such
  *software or for any infringement of patents of other rights of third parties,
  *which may result from its use. No license is granted by implication or otherwise
  *under any patent rights of Fremont Micro Devices Corporation.
  *  ******************************************************************************
  */
#ifndef __BSP_USB_H
#define __BSP_USB_H
/* Includes ---------------------------------------------------------------------*/
#include "ft32f0xx.h"
#include "usb_desc.h"
#include "usb_ep0.h"
#include "usb_ep.h"
#include "bsp_systick.h"
#include "usb_core.h"
/* Public Constant prototypes----------------------------------------------------*/

/* Public typedef ---------------------------------------------------------------*/
typedef struct
{
    uint32_t    bit0:   1;
    uint32_t    bit1:   1;
    uint32_t    bit2:   1;
    uint32_t    bit3:   1;
    uint32_t    bit4:   1;
    uint32_t    bit5:   1;
    uint32_t    bit6:   1;
    uint32_t    bit7:   1;
    uint32_t    bit8:   1;
    uint32_t    bit9:   1;
    uint32_t    bit10:  1;
    uint32_t    bit11:  1;
    uint32_t    bit12:  1;
    uint32_t    bit13:  1;
    uint32_t    bit14:  1;
    uint32_t    bit15:  1;
    uint32_t    bit16:  1;
    uint32_t    bit17:  1;
    uint32_t    bit18:  1;
    uint32_t    bit19:  1;
    uint32_t    bit20:  1;
    uint32_t    bit21:  1;
    uint32_t    bit22:  1;
    uint32_t    bit23:  1;
    uint32_t    bit24:  1;
    uint32_t    bit25:  1;
    uint32_t    bit26:  1;
    uint32_t    bit27:  1;
    uint32_t    bit28:  1;
    uint32_t    bit29:  1;
    uint32_t    bit30:  1;
    uint32_t    bit31:  1;
}VarBit;
/* Public define ----------------------------------------------------------------*/
#define usb_ep1_flag    flag1.bit0
#define f_send_mouse    flag1.bit1
#define f_send_kb           flag1.bit2
#define f_usb_suspend   flag1.bit3
#define f_sof_flag      flag1.bit4
#define f_scsi_flag     flag1.bit5



/*usb_state FLAG*/
#define USB_NORMAL              0x00
#define USB_SUSPEND_FLAG    0x01
#define USB_RESUME_FLAG     0x02

/**
  * @brief   USB_FLAG
  */
#define USB_FADDR_UPDATE_FLAG       ((uint32_t) 0x00000180)

#define USB_POWER_RESET_FLAG        ((uint32_t) 0x00000208)
#define USB_POWER_SUSPENDM_FLAG     ((uint32_t) 0x00000202)

/* Public variables prototypes --------------------------------------------------*/
extern VarBit   flag1;
extern uint8_t  epn_receive_buf[];
/* Public function prototypes----------------------------------------------------*/
void USB_Reset(void);
void USB_Init(void);
void USB_FS_IRQHandler(void);

#endif
/************************* (C) COPYRIGHT FMD *****END OF FILE*********************/

