/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : main.c
* @author    : FMD AE
* @brief     : main program body
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Includes ----------------------------------------------------------------------*/
#include "main.h"

/* Private Constant --------------------------------------------------------------*/
/* Public Constant ---------------------------------------------------------------*/
/* Private typedef ---------------------------------------------------------------*/
/* Private define ----------------------------------------------------------------*/
/* Private variables -------------------------------------------------------------*/
/* Public variables --------------------------------------------------------------*/

/* Private function prototypes ---------------------------------------------------*/
void usb_send_data(void);
/* Public function ---------------------------------------------------------------*/
/******************************************************************************
  * @brief  main program
  * @param
  * @note
  * @retval
  *****************************************************************************
*/
int main(void)
{
#if defined USB_DEBUG
    Systick_Init();
    Bsp_USART_Config();
#endif
    USB_Init();

    while (1)
    {

    }
}
/******************************************************************************
  * @brief  Test_IO_Config program
  * @param  None
  * @note
  * @retval None
  *****************************************************************************
*/
void Test_IO_Config(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;

    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);

    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_5;
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;

    GPIO_Init(GPIOA, &GPIO_InitStruct);

    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_UP;
    GPIO_Init(GPIOA, &GPIO_InitStruct);
}
/******************************************************************************
  * @brief  PA5_Test_Out program
  * @param  num
  * @note
  * @retval None
  *****************************************************************************
*/
void PA5_Test_Out(uint8_t num)
{
    Test_IO_Config();

    for (uint8_t i = 0; i < num; i++)
    {
        GPIOA->BRR = GPIO_Pin_5;
        GPIOA->BSRR = GPIO_Pin_5;
        GPIOA->BRR = GPIO_Pin_5;
    }
}

/******************************************************************************
  * @brief  Bsp_USART_GPIO_Init program
  * @param  num
  * @note
  * @retval None
  *****************************************************************************
*/
void Bsp_USART_GPIO_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;

    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);

    /*GPIO INIT*/
    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_6 | GPIO_Pin_7;
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF;
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(GPIOB, &GPIO_InitStruct);

    /*ùܶ*/
    GPIO_PinAFConfig(GPIOB, GPIO_PinSource6, GPIO_AF_0);
    GPIO_PinAFConfig(GPIOB, GPIO_PinSource7, GPIO_AF_0);
}
/******************************************************************************
  * @brief  Bsp_USART_Config program
  * @param  num
  * @note
  * @retval None
  *****************************************************************************
*/
void Bsp_USART_Config(void)
{

    USART_InitTypeDef USART_InitStruct;

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);

    /*ʼUSART1 GPIO*/
    Bsp_USART_GPIO_Init();

    /*ʼUSART1*/
    USART_InitStruct.USART_BaudRate = 115200;
    USART_InitStruct.USART_WordLength = USART_WordLength_8b;
    USART_InitStruct.USART_StopBits = USART_StopBits_1;
    USART_InitStruct.USART_Parity = USART_Parity_No;
    USART_InitStruct.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
    USART_InitStruct.USART_HardwareFlowControl = USART_HardwareFlowControl_None;

    USART_Init(USART1, &USART_InitStruct);
    USART_Cmd(USART1, ENABLE);

}

/******************************************************************************
  * @brief  fputc program
  * @param  num
  * @note
  * @retval None
  *****************************************************************************
*/
int fputc(int ch, FILE *f)
{
    while (USART_GetFlagStatus(USART1, USART_FLAG_TC) == RESET)
    {

    }
    USART_SendData(USART1, (uint8_t) ch);
    return ch;
}
/************************** (C) COPYRIGHT FMD **********************END OF FILE****/
