/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : main.c
* @author    : FMD AE
* @brief     : main program body
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Includes ----------------------------------------------------------------------*/
#include "main.h"

/* Private Constant --------------------------------------------------------------*/
/* Public Constant ---------------------------------------------------------------*/
/* Private typedef ---------------------------------------------------------------*/
/* Private define ----------------------------------------------------------------*/
/* Private variables -------------------------------------------------------------*/
/* Public variables --------------------------------------------------------------*/
uint32_t test_usb = 0;
/* Private function prototypes ---------------------------------------------------*/
void usb_send_data(void);
/* Public function ---------------------------------------------------------------*/
/******************************************************************************
  * @brief  main program
  * @param
  * @note
  * @retval
  *****************************************************************************
*/
int main(void)
{
    Systick_Init();
    USB_Init();
    Test_IO_Config();

    GPIO_SetBits(GPIOB, GPIO_Pin_2);
    SysTick_Delay_Ms(5000);

    while (1)
    {
#if 0
        /*˯߻Ѳ*/
        //1.remote wakeup:/*PA3Ϊ͵ƽʱʾа£ִлѲ*/
        //2.other device wakeup:ͨ豸ꡢ̻USBģ
        USB_Suspend();
#else
        /*ԣȫ104*/
        f_send_kb = 1;
        usb_send_data();
#endif
    }
}
/******************************************************************************
  * @brief  usb_send_data program
  * @param  None
  * @note
  * @retval None
  *****************************************************************************
*/
void usb_send_data(void)
{
    //
    if (f_send_kb)
    {
        for (uint8_t i = 0; i < KEY_SIZE; i++)
        {
            if (kb_code_tab[i][0] == 0x00)
            {
                //ͨ
                ep1_send_buf[0] = 0x00;
                ep1_send_buf[1] = 0x00;
                ep1_send_buf[2] = kb_code_tab[i][1];
                ep1_send_buf[3] = 0x00;
            }
            else if (kb_code_tab[i][0] == 0x01)
            {
                //ȼ
                ep1_send_buf[0] = kb_code_tab[i][1];
                ep1_send_buf[2] = 0x00;
                ep1_send_buf[1] = 0x00;
                ep1_send_buf[3] = 0x00;
            }

            if (USB_EP_Tx(1, ep1_send_buf, 8) != SUCCESS)
            {
                f_send_kb = 0;
            }

            SysTick_Delay_Ms(100);

            //ͷ
            ep1_send_buf[0] = 0x00;
            ep1_send_buf[2] = 0x00;
            ep1_send_buf[1] = 0x00;
            ep1_send_buf[3] = 0x00;
            if (USB_EP_Tx(1, ep1_send_buf, 8) != SUCCESS)
            {
                f_send_kb = 0;
            }
            SysTick_Delay_Ms(100);
        }
    }
}
/******************************************************************************
  * @brief  Test_IO_Config program
  * @param  None
  * @note
  * @retval None
  *****************************************************************************
*/
void Test_IO_Config(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;

    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOC, ENABLE);

    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;

    GPIO_Init(GPIOB, &GPIO_InitStruct);

    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_11;
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_UP;
    GPIO_Init(GPIOC, &GPIO_InitStruct);
}
/******************************************************************************
  * @brief  PA5_Test_Out program
  * @param  num
  * @note
  * @retval None
  *****************************************************************************
*/
void PA5_Test_Out(uint8_t num)
{
    Test_IO_Config();

    for (uint8_t i = 0; i < num; i++)
    {
        GPIOB->BRR = GPIO_Pin_2;
        GPIOB->BSRR = GPIO_Pin_2;
        GPIOB->BRR = GPIO_Pin_2;
    }
}
/************************** (C) COPYRIGHT FMD **********************END OF FILE****/
