/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : bsp_usb.h
* @author    : FMD AE
* @brief     : Header for bsp_usb.c module
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

#ifndef __BSP_USB_H
#define	__BSP_USB_H

#include "ft32f0xx.h"

//#define USB_BASE              (APBPERIPH_BASE + 0x00005C00)
//#define USB                 	((USB_TypeDef *) USB_BASE)
#define IS_USB_ALL_PERIPH(PERIPH)       ((PERIPH) == USB)
	
/**
  * @brief USB
  */
//typedef struct
//{ 
//	__IO uint8_t FADDR;      /*!<  function address register,                            Address offset: 0x00 */
//	__IO uint8_t POWER;      /*!<  power management register,                            Address offset: 0x01 */
//	__IO uint8_t INTRIN;     /*!<  interrupt register endpint0 plus IN Endpoit 1 to 7,   Address offset: 0x02 */
//	__IO uint8_t RES1; 		 /*!<  RES1          									 	 Address offset: 0x03 */
//	__IO uint8_t INTROUT;    /*!<  interrupt register for OUT Endpoints 1 to 7,          Address offset: 0x04 */
//	__IO uint8_t RES2;		 /*!<  RES2          									 	 Address offset: 0x05 */
//	__IO uint8_t INTRUSB;    /*!<  interrupt register for common USB interrrupts,        Address offset: 0x06 */
//	__IO uint8_t INTRINE;    /*!<  inerrupt enable register for INTRIN,                  Address offset: 0x07 */
//	__IO uint8_t RES3; 		 /*!<  RES3          									 	 Address offset: 0x08 */
//	__IO uint8_t INTROUTE;   /*!<  inerrupt enable register for INTROUT,                 Address offset: 0x09 */
//	__IO uint8_t RES4; 		 /*!<  RES4          									 	 Address offset: 0x0A */
//	__IO uint8_t INTRUSBE;   /*!<  inerrupt enable register for INTRUSB,                 Address offset: 0x0B */
//	__IO uint8_t FRAM1;      /*!<  frame number bits 0 to 7,                             Address offset: 0x0C */
//	__IO uint8_t FRAM2;      /*!<  frame number bits 8 to 15,                            Address offset: 0x0D */
//	__IO uint8_t INDEX;      /*!<  selecting then endpoint status and control register , Address offset: 0x0E */
//	__IO uint8_t PDCTRL;     /*!<  pull down pull up control ,                           Address offset: 0x0F */
//	__IO uint8_t INMAXP;	 /*!<  Maximum packet size for IN endpoint,                  Address offset: 0x10 */
//	union 
//	{
//		__IO uint8_t INCSR0; /*!<  control status register fie endpoint 0,           	 Address offset: 0x11 */
//		__IO uint8_t INCSR1; /*!<  Control Status register 1 for IN Endpoint,        	 Address offset: 0x11 */
//	}INCSR;
//	__IO uint8_t INCSR2;     /*!<  Control Status register 2 for IN Endpoint,            Address offset: 0x12 */
//	__IO uint8_t OUTMAXP;    /*!<  Maximum packet size for OUT endpoint,                 Address offset: 0x13 */
//	__IO uint8_t OUTCSR1;    /*!<  Control Status register 1 for OUT Endpoint,           Address offset: 0x14 */	
//	__IO uint8_t OUTCSR2;    /*!<  Control Status register 2 for OUT Endpoint,           Address offset: 0x15 */ 
//	__IO uint8_t OUTCOUNTER; /*!<  number of uint8_ts in OUT endpoint FIFO ,                Address offset: 0x16 */
//	__IO uint8_t RES5; 		 /*!<  RES5          									 	 Address offset: 0x17 */
//	__IO uint8_t RES6; 		 /*!<  RES6          									 	 Address offset: 0x18 */
//	__IO uint8_t RES7; 		 /*!<  RES7          									 	 Address offset: 0x19 */
//	__IO uint8_t FIFO0;      /*!<  FIFO for Endpoint 0,                                  Address offset: 0x20 */
//	__IO uint8_t RES8; 		 /*!<  RES8         									 	 Address offset: 0x21 */
//	__IO uint8_t RES9; 		 /*!<  RES9         									 	 Address offset: 0x22 */
//	__IO uint8_t RES10; 	 /*!<  RES10        									 	 Address offset: 0x23 */	
//	__IO uint8_t FIFO1;      /*!<  FIFO for Endpoint 1,                              	 Address offset: 0x24 */
//	__IO uint8_t RES11; 	 /*!<  RES11          									 	 Address offset: 0x25 */
//	__IO uint8_t RES12; 	 /*!<  RES12          									 	 Address offset: 0x26 */
//	__IO uint8_t RES13; 	 /*!<  RES13          									 	 Address offset: 0x27 */	
//	__IO uint8_t FIFO2;      /*!<  FIFO for Endpoint 2,                              	 Address offset: 0x28 */
//	__IO uint8_t RES14; 	 /*!<  RES14          									 	 Address offset: 0x29 */
//	__IO uint8_t RES15; 	 /*!<  RES15          									 	 Address offset: 0x2A */
//	__IO uint8_t RES16; 	 /*!<  RES16          									 	 Address offset: 0x2B */	
//	__IO uint8_t FIFO3;      /*!<  FIFO for Endpoint 3,                              	 Address offset: 0x2C */
//	__IO uint8_t RES17; 	 /*!<  RES17          									 	 Address offset: 0x2D */
//	__IO uint8_t RES18; 	 /*!<  RES18          									 	 Address offset: 0x2E */
//	__IO uint8_t RES19; 	 /*!<  RES19          									 	 Address offset: 0x2F */	
//	__IO uint8_t FIFO4;      /*!<  FIFO for Endpoint 4,                              	 Address offset: 0x30 */
//	__IO uint8_t RES20; 	 /*!<  RES20          									 	 Address offset: 0x31 */
//	__IO uint8_t RES21; 	 /*!<  RES21          									 	 Address offset: 0x32 */
//	__IO uint8_t RES22; 	 /*!<  RES22          									 	 Address offset: 0x33 */	
//	__IO uint8_t FIFO5;      /*!<  FIFO for Endpoint 5,                              	 Address offset: 0x34 */
//	__IO uint8_t RES23; 	 /*!<  RES23         									 	 Address offset: 0x35 */
//	__IO uint8_t RES24; 	 /*!<  RES24         									 	 Address offset: 0x36 */
//	__IO uint8_t RES25; 	 /*!<  RES25         									 	 Address offset: 0x37 */	
//	__IO uint8_t FIFO6;      /*!<  FIFO for Endpoint 6,                              	 Address offset: 0x38 */
//	__IO uint8_t RES26; 	 /*!<  RES26          									 	 Address offset: 0x39 */
//	__IO uint8_t RES27; 	 /*!<  RES27          									 	 Address offset: 0x3A */
//	__IO uint8_t RES28; 	 /*!<  RES28          									 	 Address offset: 0x3B */	
//	__IO uint8_t FIFO7;      /*!<  FIFO for Endpoint 7,                                  Address offset: 0x3C */
//}USB_TypeDef;
/** @defgroup I2C_registers 
  * @{
  */

#define USB_Register_FADDR              ((uint8_t)0x00)
#define USB_Register_POWER              ((uint8_t)0x01)
#define USB_Register_INTRIN             ((uint8_t)0x02)
#define USB_Register_INTROUT            ((uint8_t)0x04)
#define USB_Register_INTRUSB            ((uint8_t)0x06)
#define USB_Register_INTRINE            ((uint8_t)0x07)
#define USB_Register_INTROUTE           ((uint8_t)0x09)
#define USB_Register_INTRUSBE           ((uint8_t)0x0B)
#define USB_Register_FRAM1              ((uint8_t)0x0C)
#define USB_Register_FRAM2              ((uint8_t)0x0D)
#define USB_Register_INDEX              ((uint8_t)0x0E)
#define USB_Register_PDCTRL             ((uint8_t)0x0F)
#define USB_Register_INMAXP             ((uint8_t)0x10)
#define USB_Register_INCSR0             ((uint8_t)0x11)
#define USB_Register_INCSR1             ((uint8_t)0x11)
#define USB_Register_INCSR2             ((uint8_t)0x12)
#define USB_Register_OUTMAXP            ((uint8_t)0x13)
#define USB_Register_OUTCSR1            ((uint8_t)0x14)
#define USB_Register_OUTCSR2            ((uint8_t)0x15)
#define USB_Register_OUTCOUNTER         ((uint8_t)0x16)
#define USB_Register_FIFO0              ((uint8_t)0x20)
#define USB_Register_FIFO1              ((uint8_t)0x24)
#define USB_Register_FIFO2              ((uint8_t)0x28)
#define USB_Register_FIFO3              ((uint8_t)0x2C)
#define USB_Register_FIFO4              ((uint8_t)0x30)
#define USB_Register_FIFO5              ((uint8_t)0x34)
#define USB_Register_FIFO6              ((uint8_t)0x38)
#define USB_Register_FIFO7              ((uint8_t)0x3C)

#define IS_USB_REGISTER(REGISTER)       (((REGISTER) == USB_Register_FADDR		) || \
																				((REGISTER) == USB_Register_POWER     ) || \
																				((REGISTER) == USB_Register_INTRIN    ) || \
																				((REGISTER) == USB_Register_INTROUT   ) || \
																				((REGISTER) == USB_Register_INTRUSB   ) || \
																				((REGISTER) == USB_Register_INTRINE   ) || \
																				((REGISTER) == USB_Register_INTROUTE  ) || \
																				((REGISTER) == USB_Register_INTRUSBE  ) || \
																				((REGISTER) == USB_Register_FRAM1     ) || \
																				((REGISTER) == USB_Register_FRAM2     ) || \
																				((REGISTER) == USB_Register_INDEX     ) || \
																				((REGISTER) == USB_Register_PDCTRL    ) || \
																				((REGISTER) == USB_Register_INMAXP    ) || \
																				((REGISTER) == USB_Register_INCSR0    ) || \
																				((REGISTER) == USB_Register_INCSR1    ) || \
																				((REGISTER) == USB_Register_INCSR2    ) || \
																				((REGISTER) == USB_Register_OUTMAXP   ) || \
																				((REGISTER) == USB_Register_OUTCSR1   ) || \
																				((REGISTER) == USB_Register_OUTCSR2   ) || \
																				((REGISTER) == USB_Register_OUTCOUNTER) || \
																				((REGISTER) == USB_Register_FIFO0     ) || \
																				((REGISTER) == USB_Register_FIFO1     ) || \
																				((REGISTER) == USB_Register_FIFO2     ) || \
																				((REGISTER) == USB_Register_FIFO3     ) || \
																				((REGISTER) == USB_Register_FIFO4     ) || \
																				((REGISTER) == USB_Register_FIFO5     ) || \
																				((REGISTER) == USB_Register_FIFO6     ) || \
																				((REGISTER) == USB_Register_FIFO7     ))


/**
  * @brief USB_EP
  */
#define	USB_EP_0	((uint8_t)0x00)
#define	USB_EP_1	((uint8_t)0x01)
#define	USB_EP_2	((uint8_t)0x02)
#define	USB_EP_3	((uint8_t)0x03)
#define	USB_EP_4	((uint8_t)0x04)
#define	USB_EP_5	((uint8_t)0x05)
#define	USB_EP_6	((uint8_t)0x06)
#define	USB_EP_7	((uint8_t)0x07)

#define	IS_USB_EP(EPn)			(((EPn) >= 0x00) && ((EPn) < 0x08))


/**
  * @brief USB_PDCTRL
  */
#define	USB_PDCTRL_FLAG 		((uint8_t)(0x03))	

#define	USB_PDCTRL_PD_DISABLE	((uint8_t)(0x00))
#define	USB_PDCTRL_PD_ENABLE	((uint8_t)(0x02))

#define	USB_PDCTRL_PU_DISABLE	((uint8_t)(0x00))
#define	USB_PDCTRL_PU_ENABLE	((uint8_t)(0x01))

#define	IS_USB_PDCTRL(PDCTRL)	(((PDCTRL) == USB_PDCTRL_PD_DISABLE) || \
								((PDCTRL) == USB_PDCTRL_PD_ENABLE) || \
								((PDCTRL) == USB_PDCTRL_PU_DISABLE) || \
								((PDCTRL) == USB_PDCTRL_PU_ENABLE))

/**
  * @brief   USB_FLAG
  */
#define	USB_FADDR_UPDATE_FLAG		((uint32_t) 0x00000180)

#define	USB_POWER_RESET_FLAG		((uint32_t) 0x00000208)
#define	USB_POWER_SUSPENDM_FLAG		((uint32_t) 0x00000202)

/**
  * @brief   USB_IT_FLAG
  */
#define	USB_IT_IN_EP0_FLAG			((uint32_t) 0x00000101)
#define	USB_IT_IN_EP1_FLAG			((uint32_t) 0x00000102)
#define	USB_IT_IN_EP2_FLAG			((uint32_t) 0x00000104)
#define	USB_IT_IN_EP3_FLAG			((uint32_t) 0x00000108)
#define	USB_IT_IN_EP4_FLAG			((uint32_t) 0x00000110)
#define	USB_IT_IN_EP5_FLAG			((uint32_t) 0x00000120)
#define	USB_IT_IN_EP6_FLAG			((uint32_t) 0x00000140)
#define	USB_IT_IN_EP7_FLAG			((uint32_t) 0x00000180)

#define	USB_IT_OUT_EP1_FLAG			((uint32_t) 0x00000202)
#define	USB_IT_OUT_EP2_FLAG			((uint32_t) 0x00000204)
#define	USB_IT_OUT_EP3_FLAG			((uint32_t) 0x00000208)
#define	USB_IT_OUT_EP4_FLAG			((uint32_t) 0x00000210)
#define	USB_IT_OUT_EP5_FLAG			((uint32_t) 0x00000220)
#define	USB_IT_OUT_EP6_FLAG			((uint32_t) 0x00000240)
#define	USB_IT_OUT_EP7_FLAG			((uint32_t) 0x00000280)

#define	USB_IT_USB_SUSPEND_FLAG		((uint32_t) 0x00000401)
#define	USB_IT_USB_RESUME_FLAG		((uint32_t) 0x00000402)
#define	USB_IT_USB_RESET_FLAG			((uint32_t) 0x00000404)
#define	USB_IT_USB_SOF_FLAG				((uint32_t) 0x00000408)

void USB_Reset(void);
void USB_Init(void);
void Set_Sysclk_48M(void);


void USB_PDCTRLConfig(uint8_t PDCT);


void USB_ITConfig(uint32_t USB_IT, FunctionalState NewState);

void usb_send_data(uint8_t* buf,uint32_t len,uint8_t Ep);

#endif
