/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : uart.h
* @author    : FMD AE
* @brief     : Header for uart.c module
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

#ifndef __UART_H
#define __UART_H

#include "ft32f0xx.h"

#define MAX_COM_BUFFER_SIZE         512

typedef struct
{
    uint8_t recevBuffer[MAX_COM_BUFFER_SIZE];
    uint16_t recevCnt;
    uint8_t RecFlg;
    uint8_t ComFlg;
    uint8_t IniFlg;
    uint32_t saveTime;
} USART_STRUCT;

extern USART_STRUCT usartPara;
void SendSerialData(uint8_t *bufer, uint16_t cnt);


void IniUart(void);
void ReIniUartByUSB(uint32_t bitrate, uint8_t format, uint8_t paritytype, uint8_t datatype);

#endif
