/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : bsp_systick.c
* @author    : FMD AE
* @brief     : bsp_systick program body
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Includes ----------------------------------------------------------------------*/

#include "bsp_systick.h"

__IO uint32_t TimingDelay;

/**********************************************************************************
  * @brief  Initial System tick
  * @param  none
    * @note   clock tick
  * @retval None
  *********************************************************************************
*/
void Systick_Init(void)
{
    if (SysTick_Config(48000))
    {
        while (1);
    }
    SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK);

}
/**********************************************************************************
  * @brief  Delay time decrement
  * @param  none
    * @note   clock tick
  * @retval None
  *********************************************************************************
*/
void TimingDelay_Decrement(void)
{
    if (TimingDelay != 0x00)
    {
        TimingDelay--;
    }
}

