/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : main.c
* @author    : FMD AE
* @brief     : main program body
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Includes ----------------------------------------------------------------------*/

#include "cmsis_os2.h"
#include "osObjects.h"
#include "rl_usb.h"


#include "bsp_usb.h"
#include "main.h"
#include "uart.h"

M_EPBOUT_BUF gBulkoutData2;




/**********************************************************************************
  * @brief main
    * @param  none
    * @note
  * @retval None
  *********************************************************************************
*/
int main(void)
{
    Set_Sysclk_48M();
    Systick_Init();
    USB_Init();
    IniUart();
    osKernelInitialize();                 // Initialize OS
    osThreadNew(app_main, NULL, NULL);    // Create application main thread

    for (;;)
    {

    }
}

/**********************************************************************************
  * @brief app_main
    * @param  *argument
    * @note
  * @retval None
  *********************************************************************************
*/
void app_main(void *argument)
{
    (void)argument;

    while (!USBD_Configured(0U));         // Wait for USB Device to configure

    // Create USB_UART Thread
    USB_UART_ThreadId = osThreadNew(USB_UART_Thread, NULL, NULL);

    osDelay(osWaitForever);
    for (;;) {};
}
