 * ----------------------------------------------------------------------
 *
 * $Date:        11. August 2023
 * $Revision:    V0.0.0
 *
 * Project:      CMSIS-DAP Examples FT32F072
 * Title:        cmsis_compiler.h CMSIS-DAP Wrap module for FT32
 *
 *---------------------------------------------------------------------------*/
#ifndef _CMSIS_COMPILER_H_
#define _CMSIS_COMPILER_H_

/**
  * I don't like the original header file from CMSIS package because it
  * will include a bunch of unrelated header files.
  */

//#if defined(__GNUC__)
//  #define __WEAK                  __attribute__((weak))
//  #define __NO_RETURN             __attribute__((noreturn))
//  #define __STATIC_INLINE         static inline
//  #define __STATIC_FORCEINLINE    static inline
//  #define __nop()                 __NOP()

//  typedef _Bool                   bool;
//  #define true                    1
//  #define false                   0

//  #include <stdint.h>
//#endif

#if defined(__ICCARM__)           /* for IAR EWARM */
  #define __NO_RETURN             __noreturn
  #define __STATIC_INLINE         static inline
  #define __STATIC_FORCEINLINE    static inline
  
  typedef _Bool                   bool;
  #define true                    1
  #define false                   0
#endif

#if defined(__CC_ARM)             /* for Keil MDK */
	#define __WEAK                  __weak
	#define __NO_RETURN             __declspec(noreturn)
  #define __STATIC_FORCEINLINE    static __inline

  typedef _Bool                   bool;
  #define true                    1
  #define false                   0

	/**
	  * I don't know how to omit "-D_RTX_" from the command line parameters
	  * so I insert my header file hear.
	  */
	#include "device.h"
#endif

#endif
