/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : device.c
* @author    : FMD AE
* @brief     : device program body
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Includes ----------------------------------------------------------------------*/

#include "cmsis_compiler.h"
#include "cmsis_os2.h"
#include "rl_usb.h"
#include "device.h"

#include "usbd_def.h"

extern int  gnDevState;
/* Private variables ---------------------------------------------------------*/

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
    /* USER CODE BEGIN Error_Handler_Debug */
    /* User can add his own implementation to report the HAL error return state */

    /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
    /* USER CODE BEGIN 6 */
    /* User can add his own implementation to report the file name and line number,
       tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
    /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */


/**
  * Replace CMSIS RTOS api
  */
static volatile int osFlags;  /* Use "volatile" to prevent GCC optimizing the code. */

/**********************************************************************************
  * @brief  none
    * @note
  * @retval None
  *********************************************************************************
*/
void osKernelInitialize(void)
{
    osFlags = 0;
    return;
}

/**********************************************************************************
  * @brief  osThreadNew
    * @param  (*func)(void *):
    * @param  *n:
    * @param  *ctx:
    * @note
  * @retval None
  *********************************************************************************
*/
osThreadId_t osThreadNew(void (*func)(void *), void *n, void *ctx)
{
    (void)n;
    (*func)(ctx);
    return 0;
}

/**********************************************************************************
  * @brief  osThreadFlagsSet
    * @param  tid:
    * @param  f:
    * @note
  * @retval None
  *********************************************************************************
*/
void osThreadFlagsSet(int tid, int f)
{
    (void)tid;

    osFlags |= f;
    return;
}



/**********************************************************************************
  * @brief  USBD_Configured
    * @param  none
    * @note
  * @retval None
  *********************************************************************************
*/
int USBD_Configured(int n)
{
    (void)n;
    return (gnDevState == DEVSTATE_CONFIG ? 1 : 0);
}






