#ifndef _CONFIG_H_
#define _CONFIG_H_

/* Define maximum packet size for endpoint 0 */
#define M_EP0_MAXP      8

/* Define maximum number of interfaces in a configuration */
#define M_MAXIFS        8

/* Define values for Standard Device Descriptor */
#define M_DEVDSC_CLASS          0x00    /* Device Class */
#define M_DEVDSC_SUBCLASS       0x00    /* Device SubClass */
#define M_DEVDSC_PROTOCOL       0x00    /* Device Protocol */
#define M_DEVDSC_VENDOR         0x8888  /* Vendor ID */
#define M_DEVDSC_PRODUCT        0x1029  /* Product ID */
#define M_DEVDSC_RELEASE        0x0100  /* Release number */
#define M_DEVDSC_MANUI          1       /* Manufacturer string index */
#define M_DEVDSC_PRODI          2       /* Product string index */
#define M_DEVDSC_SERIALI        3       /* Serial number string index */
#define M_DEVDSC_CONFIGS        1       /* Number of configurations */ //2


/* Define values for descriptors in configuration 1 */
#define M_CFG1_NUMIFS           2       /* Number of interfaces */
#define M_CFG1_CFGI             0       /* Configuration description string index */
#define M_CFG1_ATTRIBUTES       0xE0    /* Configuration attributes */		//0xE0
#define M_CFG1_MAXPOWER         0xC8    /* Maximum power (units of 2 mA) */

/* Interface 0, alternate 0 */
#define M_CFG1_I0A0_NUMEPS      2       /* Number of endpoints */
#define M_CFG1_I0A0_IFCLASS     3       /* Interface class */
#define M_CFG1_I0A0_IFSUBCLASS  1       /* Interface subclass */	//0
#define M_CFG1_I0A0_IFPROTOCOL  2       /* Interface protocol */	//1
#define M_CFG1_I0A0_IFI         0       /* Interface string index */
#define M_CFG1_I0A0_0_EPADDR    0x82    /* Endpoint address (endpoint 2 IN) */
#define M_CFG1_I0A0_0_ATTRIB    0x03    /* Endpoint attributes () */	//1
#define M_CFG1_I0A0_0_MAXP      0x04  	/* Endpoint max packet size (64) *///0x0040
#define M_CFG1_I0A0_0_INTER     0x0A    /* Endpoint interval */	//0
#define M_CFG1_I0A0_1_EPADDR    0x01    /* Endpoint address (endpoint 1 OUT) */
#define M_CFG1_I0A0_1_ATTRIB    0x03    /* Endpoint attributes () */
#define M_CFG1_I0A0_1_MAXP      0x0040  /* Endpoint max packet size (64) */
#define M_CFG1_I0A0_1_INTER     0x0A    /* Endpoint interval*/

/* Interface 1, alternate 0 */
#define M_CFG1_I1A0_NUMEPS      2       /* Number of endpoints */
#define M_CFG1_I1A0_IFCLASS     0x03    /* Interface class */
#define M_CFG1_I1A0_IFSUBCLASS  0x01    /* Interface subclass */
#define M_CFG1_I1A0_IFPROTOCOL  0x01    /* Interface protocol */
#define M_CFG1_I1A0_IFI         0       /* Interface string index */
#define M_CFG1_I1A0_0_EPADDR    0x83    /* Endpoint address (endpoint 2 IN) */
#define M_CFG1_I1A0_0_ATTRIB    0x03    /* Endpoint attributes () */
#define M_CFG1_I1A0_0_MAXP      0x08  	/* Endpoint max packet size (64) */
#define M_CFG1_I1A0_0_INTER     0x0A    /* Endpoint interval */
#define M_CFG1_I1A0_1_EPADDR    0x04    /* Endpoint address (endpoint 2 OUT) */
#define M_CFG1_I1A0_1_ATTRIB    0x03    /* Endpoint attributes () */
#define M_CFG1_I1A0_1_MAXP      0x08	  /* Endpoint max packet size (64) */
#define M_CFG1_I1A0_1_INTER     0x0A    /* Endpoint interval */

/* Interface 1, alternate 1 */
#define M_CFG1_I1A1_NUMEPS      2       /* Number of endpoints */
#define M_CFG1_I1A1_IFCLASS     3       /* Interface class */
#define M_CFG1_I1A1_IFSUBCLASS  0       /* Interface subclass */
#define M_CFG1_I1A1_IFPROTOCOL  0       /* Interface protocol */
#define M_CFG1_I1A1_IFI         0       /* Interface string index */
#define M_CFG1_I1A1_0_EPADDR    0x82    /* Endpoint address (endpoint 2 IN) */
#define M_CFG1_I1A1_0_ATTRIB    0x02    /* Endpoint attributes (bulk) */
#define M_CFG1_I1A1_0_MAXP      0x0040  /* Endpoint max packet size (64) */
#define M_CFG1_I1A1_0_INTER     0       /* Endpoint interval */
#define M_CFG1_I1A1_1_EPADDR    0x02    /* Endpoint address (endpoint 2 OUT) */
#define M_CFG1_I1A1_1_ATTRIB    0x02    /* Endpoint attributes (bulk) */
#define M_CFG1_I1A1_1_MAXP      0x0040  /* Endpoint max packet size (64) */
#define M_CFG1_I1A1_1_INTER     0       /* Endpoint interval */


/* Define values for descriptors in configuration 2 */
#define M_CFG2_NUMIFS           2       /* Number of interfaces */
#define M_CFG2_CFGI             0       /* Configuration description string index */
#define M_CFG2_ATTRIBUTES       0x00    /* Configuration attributes */
#define M_CFG2_MAXPOWER         0xC8    /* Maximum power (units of 2 mA) */

/* Interface 0, alternate 0 */
#define M_CFG2_I0A0_NUMEPS      2       /* Number of endpoints */
#define M_CFG2_I0A0_IFCLASS     3       /* Interface class */
#define M_CFG2_I0A0_IFSUBCLASS  0       /* Interface subclass */
#define M_CFG2_I0A0_IFPROTOCOL  0       /* Interface protocol */
#define M_CFG2_I0A0_IFI         0       /* Interface string index */
#define M_CFG2_I0A0_0_EPADDR    0x81    /* Endpoint address (endpoint 1 IN) */
#define M_CFG2_I0A0_0_ATTRIB    0x02    /* Endpoint attributes (bulk) */
#define M_CFG2_I0A0_0_MAXP      0x0040  /* Endpoint max packet size (64) */
#define M_CFG2_I0A0_0_INTER     0       /* Endpoint interval */
#define M_CFG2_I0A0_1_EPADDR    0x01    /* Endpoint address (endpoint 1 OUT) */
#define M_CFG2_I0A0_1_ATTRIB    0x02    /* Endpoint attributes (bulk) */
#define M_CFG2_I0A0_1_MAXP      0x0040  /* Endpoint max packet size (64) */
#define M_CFG2_I0A0_1_INTER     0       /* Endpoint interval */

/* Interface 1, alternate 0 */
#define M_CFG2_I1A0_NUMEPS      2       /* Number of endpoints */
#define M_CFG2_I1A0_IFCLASS     3       /* Interface class */
#define M_CFG2_I1A0_IFSUBCLASS  0       /* Interface subclass */
#define M_CFG2_I1A0_IFPROTOCOL  0       /* Interface protocol */
#define M_CFG2_I1A0_IFI         0       /* Interface string index */
#define M_CFG2_I1A0_0_EPADDR    0x82    /* Endpoint address (endpoint 2 IN) */
#define M_CFG2_I1A0_0_ATTRIB    0x02    /* Endpoint attributes (bulk) */
#define M_CFG2_I1A0_0_MAXP      0x0040  /* Endpoint max packet size (64) */
#define M_CFG2_I1A0_0_INTER     0       /* Endpoint interval */
#define M_CFG2_I1A0_1_EPADDR    0x02    /* Endpoint address (endpoint 2 OUT) */
#define M_CFG2_I1A0_1_ATTRIB    0x02    /* Endpoint attributes (bulk) */
#define M_CFG2_I1A0_1_MAXP      0x0040  /* Endpoint max packet size (64) */
#define M_CFG2_I1A0_1_INTER     0       /* Endpoint interval */


#endif /* _CONFIG_H_ */

