/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : usb_fat.h
* @author    : FMD AE
* @brief     : Header for usb_fat.c module
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

#ifndef __USB_FAT_H__
#define __USB_FAT_H__

/* Includes ---------------------------------------------------------------------*/
#include "ft32f0xx.h"
/* Public Constant prototypes----------------------------------------------------*/

/* Public typedef ---------------------------------------------------------------*/

/* Public define ----------------------------------------------------------------*/
/********** ʱʽ16BitsΪ **************
 Bits15~11ʾСʱȡֵΪ0~23
 Bits10~5ʾ֣ȡֵΪ0~59
 Bits4~0ʾ룬ȡֵΪ0~29ÿλΪ2룬ʵֵΪֵ2
*/

/********* ڸʽ16BitsΪ  *************
 Bits15~9ʾݣȡֵΪ0~127ʾ1980ֵ
          ʵʵΪֵ1980ɱʾ2107ꣻ

 Bits8~5ʾ·ݣȡֵΪ1~12
 Bits4~0ʾȡֵΪ1~31
*/

//16λʱʽĸֽ
#define TIME_HB(H,M,S) ((H<<11|M<<5|S)>>8)
//16λʱʽĵֽ
#define TIME_LB(H,M,S) ((H<<11|M<<5|S) & 0xff)

//16λڸʽĸֽ
#define DATE_HB(Y,M,D) (((((Y)-1980)<<9)|((M)<<5)|(D))>>8)
//16λڸʽĵֽ
#define DATE_LB(Y,M,D) (((((Y)-1980)<<9)|((M)<<5)|(D)) & 0xff)

/* Public variables prototypes --------------------------------------------------*/
extern const uint8_t RootDir[];
extern const uint8_t TestFileData[];
extern const uint8_t Zeros[];
extern const uint8_t Fat[];
extern const uint8_t Dbr[];
/* Public function prototypes----------------------------------------------------*/
#endif
/************************* (C) COPYRIGHT FMD *****END OF FILE*********************/

