/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : usb_scsi.h
* @author    : FMD AE
* @brief     : Header for usb_scsi.c module
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

#ifndef __USB_SCSI_H__
#define __USB_SCSI_H__

/* Includes ---------------------------------------------------------------------*/
#include "ft32f0xx.h"
#include "usb_core.h"
#include "usb_fat.h"
/* Public Constant prototypes----------------------------------------------------*/

/* Public typedef ---------------------------------------------------------------*/

/* Public define ----------------------------------------------------------------*/

/* Endpoint states */
#define M_EP_IDLE      0
#define M_EP_RX        1
#define M_EP_TX        2

/*CBW STAGE*/
#define CBW_CMD_STAGE       0
#define CBW_DATA_STAGE      1
#define CBW_STATE_STAGE     2

/*SCSI CMD*/
#define INQUIRY_CMD             0x12
#define READ_FT_CAPAC_CMD       0x23
#define READ_CAPAC_CMD          0x25
#define READ10_CMD              0x28
#define WRITE10_CMD             0x2A
#define REQUEST_SENSE_CMD       0x03
#define TEST_UNIT_READY_CMD     0x00

/* Public variables prototypes --------------------------------------------------*/
extern const uint8_t Inquiry_Data[];
/* Public function prototypes----------------------------------------------------*/


void Get_Disk_Data(PM_EPBIN_STATUS pbistate);
void USB_SCSI_CMD(PM_EPBIN_STATUS pbistate, pUSBC_CBW_TYPE usb_cbw);
void USB_SCSI_CMD_STAGE(PM_EPBIN_STATUS pbistate, int Residue, uint8_t Status);
uint32_t USB_CBW_Data_TransferLength(pUSBC_CBW_TYPE cbw_temp);
void USB_CSW_Set(int Residue, uint8_t Status);

#endif
/************************* (C) COPYRIGHT FMD *****END OF FILE*********************/

