/********** (C) COPYRIGHT 2021 Fremont Micro Devices (SZ) Corporation *********
* @file      : usb_scsi.c
* @author    : FMD AE
* @brief     : usb_scsi program body
* @version   : V1.0.0
* @data      : 2021-09-14
******************************************************************************
* @attention
* COPYRIGHT (C) 2021 Fremont Micro Devices (SZ) Corporation All rights reserved.
* This software is provided by the copyright holders and contributors,and the
*   software is believed to be accurate and reliable. However, Fremont Micro
*   Devices (SZ) Corporation assumes no responsibility for the consequences of
*   use of such software or for any infringement of patents of other rights
*   of third parties, which may result from its use. No license is granted by
*   implication or otherwise under any patent rights of Fremont Micro Devices (SZ)
*   Corporation.
*******************************************************************************/

/* Includes ----------------------------------------------------------------------*/
#include "usb_scsi.h"
/* Private Constant --------------------------------------------------------------*/
/* Public Constant ---------------------------------------------------------------*/
/* Private typedef ---------------------------------------------------------------*/
/* Private define ----------------------------------------------------------------*/
/* Private variables -------------------------------------------------------------*/
uint32_t ByteAddr;  //ֽڵַ
/* Public variables --------------------------------------------------------------*/
const uint8_t Some_Data[] =
{
    0x03, 0x00, 0x00, 0x00
};
const uint8_t Inquiry_Data[36] =
{
    0x00,/**/
    0x80,/*Ƴ豸*/
    0x00,
    0x01,/*Ӧݸʽ*/
    0x1f,/*ݳ*/
    /*5-7*/
    0x00,
    0x00,
    0x00,
    /*Ϣ*/
    'F',
    0x00,
    'M',
    0x00,
    'D',
    0x00,
    0x00,
    0x00,
    /*ƷϢ*/
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    0x00,
    /*Ʒ汾Ϣ*/
    0x00,
    0x00,
    0x00,
    0x00
};

const uint8_t Read_Format_Capacities_Data[] =
{
    0x00, 0x00, 0x00, //
    0x08,  //б
    0x01, 0x00, 0x00, 0x00,  //(֧8GB)
    0x03, //Ϊ3ʾֵ֧ĸʽ
    0x00, 0x02, 0x00 //ÿСΪ512ֽ
};

const uint8_t Read_Capacity_Data[] =
{
    0x00, 0x03, 0xFF, 0xFF, //ܹʵ߼ַ
    0x00, 0x00, 0x02, 0x00 //ĳ
//Ըô̵Ϊ
//(0x3FFFF+1)*0x200 = 0x8000000 = 128*1024*1024 = 128MB.
};

const uint8_t REQUEST_Sense_Data[18] =
{
    0x70, //룬̶Ϊ0x70
    0x00, //
    0x05, //Sense KeyΪ0x05ʾЧILLEGAL REQUEST
    0x00, 0x00, 0x00, 0x00, //InformationΪ0
    0x0A, //ݳΪ10ֽ
    0x00, 0x00, 0x00, 0x00, //
    0x20, //Additional Sense Code(ASC)Ϊ0x20ʾЧ루INVALID COMMAND OPERATION CODE
    0x00, //Additional Sense Code Qualifier(ASCQ)Ϊ0
    0x00, 0x00, 0x00, 0x00 //
};

/* Private function prototypes ---------------------------------------------------*/

/* Public function ---------------------------------------------------------------*/
/******************************************************************************
  * @brief  USB_CBW_Data_TransferLength program
  * @param  cbw_temp
  * @note   Get Lba byte number
  * @retval Len
  *****************************************************************************
*/
uint32_t USB_CBW_Data_TransferLength(pUSBC_CBW_TYPE cbw_temp)
{
    uint32_t Len;

//CBW[8]~CBW[11]Ϊ䳤ȣС˽ṹ
    Len = cbw_temp->dCBWDataTransferLength[3] << 24 | cbw_temp->dCBWDataTransferLength[2] << 16 | \
          cbw_temp->dCBWDataTransferLength[1] << 8  | cbw_temp->dCBWDataTransferLength[0];

    return Len;

}


/******************************************************************************
  * @brief  GetLba program
  * @param  None
  * @note   Get Lba byte number
  * @retval Lba
  *****************************************************************************
*/
uint32_t GetLba(void)
{
    uint32_t Lba;
    pUSBC_CBW_TYPE cbw = (void *)epn_receive_buf;
//дʱCBW[17]~CBW[20]Ϊ߼ַ˽ṹ

    Lba = cbw->CBWCB[2] << 24 | cbw->CBWCB[3] << 16 | cbw->CBWCB[4] << 8 | cbw->CBWCB[5];

    return Lba;
}
/******************************************************************************
  * @brief  Get_Disk_Data program
  * @param  pbistate:
  * @note
  * @retval None
  *****************************************************************************
*/
void Get_Disk_Data(PM_EPBIN_STATUS pbistate)
{
    //жϸ÷ʲô
    if (ByteAddr == 0) pbistate->pData = (void *)Dbr; //DBR
    if (ByteAddr == 512) pbistate->pData = (void *)Fat; //FAT
    if ((ByteAddr >= 576) && (ByteAddr < 16896)) pbistate->pData = (void *)Zeros;
    if (ByteAddr == 16896) pbistate->pData = (void *)Fat; //FATFAT
    if ((ByteAddr >= 16960) && (ByteAddr < 33280)) pbistate->pData = (void *)Zeros;
    if (ByteAddr == 33280) pbistate->pData = (void *)RootDir; //ظĿ¼
    if ((ByteAddr >= 33344) && (ByteAddr < 49664)) pbistate->pData = (void *)Zeros;
    if (ByteAddr == 49664) pbistate->pData = (void *)TestFileData; //ļ
    if (ByteAddr > 50175) pbistate->pData = (void *)Zeros;

    ByteAddr += M_EP_MAXP; //ֽڵַÿηȵ
}


/******************************************************************************
  * @brief  USB_CSW_Set program
  * @param  Residue: Residue byte
  *         Status:
  * @note   Fill CSW
  * @retval None
  *****************************************************************************
*/
void USB_CSW_Set(int Residue, uint8_t Status)
{
    __IO pUSBC_CBW_TYPE cbw = &usb_cbw;

    //CSWǩʵԲÿζõģ
    //ʼʼһξˣÿζ
    usb_csw.dCSWSignature[0] = 0x55;
    usb_csw.dCSWSignature[1] = 0x53;
    usb_csw.dCSWSignature[2] = 0x42;
    usb_csw.dCSWSignature[3] = 0x53;

    //dCBWTagCSWdCSWTagȥ
    usb_csw.dCSWTag[0] = cbw->dCBWTag[0];
    usb_csw.dCSWTag[1] = cbw->dCBWTag[1];
    usb_csw.dCSWTag[2] = cbw->dCBWTag[2];
    usb_csw.dCSWTag[3] = cbw->dCBWTag[3];

    //ʣֽ
    usb_csw.dCSWDataResidue[0] = Residue & 0xFF;
    usb_csw.dCSWDataResidue[1] = (Residue >> 8) & 0xFF;
    usb_csw.dCSWDataResidue[2] = (Residue >> 16) & 0xFF;
    usb_csw.dCSWDataResidue[3] = (Residue >> 24) & 0xFF;

    //ִе״̬0ʾɹ1ʾʧܡ
    usb_csw.bCSWStatus = Status;
}

/******************************************************************************
  * @brief  USB_SCSI_CMD program
  * @param  pbistate
  *         cbw_temp
  * @note
  * @retval None
  *****************************************************************************
*/
void USB_SCSI_CMD(PM_EPBIN_STATUS pbistate, pUSBC_CBW_TYPE cbw_temp)
{
    uint16_t data_len = 0;

    /*ݽ׶*/
    USB_CBW_STATUS = CBW_DATA_STAGE;

    switch (cbw_temp->CBWCB[0])
    {
    /*ѯINQUIRY*/
    case    INQUIRY_CMD:            //0x12:
        data_len = USB_CBW_Data_TransferLength(cbw_temp);
        if (data_len > sizeof(Inquiry_Data))
        {
            data_len = sizeof(Inquiry_Data);
        }
        pbistate->pData = (void *)Inquiry_Data;
        pbistate->nBytesLeft = data_len;

        Endpoint_Tx_data(pbistate);
        break;
    /*ʽREAD FORMAT CAPACITIES*/
    case    READ_FT_CAPAC_CMD:                  //0x23:
        pbistate->pData = (void *)Read_Format_Capacities_Data;
        data_len = sizeof(Read_Format_Capacities_Data);
        if (data_len > sizeof(Read_Format_Capacities_Data))
        {
            data_len = sizeof(Read_Format_Capacities_Data);
        }
        pbistate->nBytesLeft = data_len;

        Endpoint_Tx_data(pbistate);
        break;
    /*READ CAPACITY*/
    case    READ_CAPAC_CMD:         //0x25:
        pbistate->pData = (void *)Read_Capacity_Data;
        data_len = USB_CBW_Data_TransferLength(cbw_temp);
        if (data_len > sizeof(Read_Capacity_Data))
        {
            data_len = sizeof(Read_Capacity_Data);
        }
        pbistate->nBytesLeft = data_len;

        Endpoint_Tx_data(pbistate);
        break;
    /*read(10)*/
    case READ10_CMD:        //0x28:
#if defined USB_DEBUG
        printf("read10 data\r\n");
#endif
        /*ȡҪȡĵַ*/
        ByteAddr = GetLba() * 512;
        /*Ҫȡֽ*/
        data_len = (cbw_temp->dCBWDataTransferLength[3] << 24 | cbw_temp->dCBWDataTransferLength[2] << 16 | \
                    cbw_temp->dCBWDataTransferLength[1] << 8  |   cbw_temp->dCBWDataTransferLength[0]);
        pbistate->nBytesLeft = data_len;
        Get_Disk_Data(pbistate);
        Endpoint_Tx_data(pbistate);
        break;
    /*write(10)*/
    case WRITE10_CMD:           //0x2A:
        data_len = (cbw_temp->dCBWDataTransferLength[3] << 24 | cbw_temp->dCBWDataTransferLength[2] << 16 | \
                    cbw_temp->dCBWDataTransferLength[1] << 8  |   cbw_temp->dCBWDataTransferLength[0]);
        recieved_len = data_len;

        break;
    /*REQUEST SENSE*/
    case REQUEST_SENSE_CMD:     //0x03:
        pbistate->pData = (void *)REQUEST_Sense_Data;

        data_len = USB_CBW_Data_TransferLength(cbw_temp);
        if (data_len > sizeof(REQUEST_Sense_Data))
        {
            data_len = sizeof(REQUEST_Sense_Data);
        }
        pbistate->nBytesLeft = data_len;
        Endpoint_Tx_data(pbistate);
        break;
    /*TEST UNIT READY*/
    case TEST_UNIT_READY_CMD:       //0x00:
        USB_CBW_STATUS = CBW_CMD_STAGE;
        USB_SCSI_CMD_STAGE(pbistate, 0, 0);
        Endpoint_Tx_data(pbistate);
        break;
    case    0x1a:
        pbistate->pData = (void *)Some_Data;

        data_len = USB_CBW_Data_TransferLength(cbw_temp);
        if (data_len > sizeof(Some_Data))
        {
            data_len = sizeof(Some_Data);
        }
        pbistate->nBytesLeft = data_len;
        Endpoint_Tx_data(pbistate);
        break;
    default:
//          if(cbw_temp->bmCBWFlags & 0x80)
//          {
//              //
//
//          }
        USB_CBW_STATUS = CBW_CMD_STAGE;
        USB_SCSI_CMD_STAGE(pbistate, 0, 1);
        Endpoint_Tx_data(pbistate);
        break;
    }
}
/******************************************************************************
  * @brief  USB_SCSI_CMD_STAGE program
  * @param  pbistate
  *         Residue
  *         Status
  * @note
  * @retval None
  *****************************************************************************
*/
void USB_SCSI_CMD_STAGE(PM_EPBIN_STATUS pbistate, int Residue, uint8_t Status)
{
    if (Residue == M_EP_NODATA)
    {
        Residue = 0;
    }
    USB_CSW_Set(Residue, Status);

    pbistate->byEP = USE_EP_N(2);
    pbistate->pData = (void *)&usb_csw;
    pbistate->nBytesLeft = sizeof(usb_csw);
}
